<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>

mixin req(req_num, title)
  section(anchor="REQ_" + req_num)
    name
      strong REQ_#{req_num}
      |  #{title}
    block

mixin xreq(req_num)
  xref(target="REQ_" + req_num format='title')
    if block
      block

// categories: std | bcp | info | exp | historic
rfc(category='std' number='2820018' consensus='false' ipr='trust200902' docName='sambuca-software-requirements-01' submissionType='be-cem-mro' xml:lang='en' version='3')
  front
    title(abbrev='Short Template Document') SamBuCa project software requirements
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    date(year='2022' month="June" day="1")

    keyword template

    abstract
      t This document aggregates the SamBuCa project software requirements.

  middle

    section
      name Introduction
      t
        | This document aggregates the SamBuCa project software requirements.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

      section
        name Terminology

        section
          name Settings and Configuration

          t
            | In this document, a #[tt setting] identifies a value that may be modified at runtime,
            | when #[tt configuration] identifies a value that is pre-determined, either at
            | compile time or program startup, and #[bcp14 MAY] not be modified at runtime.

    +req("01", "Motion Control")
      +req("01.1", "Absolute movement")

        t
          | The software #[bcp14 MUST] provide an absolute positioning feature.

        +req("01.1.1", "Absolute movement boundaries")
          t
            | Absolute movement order #[bcp14 MUST] be rejected when out of boundaries, a
            | minimum and maximum position for each axis #[bcp14 SHOULD] be available as settings.

      +req("01.2", "Relative movement")

        t A relative positioning interface #[bcp14 MUST] be provided.

        t
          | #[+xreq("01.1.1") Absolute movement boundaries] #[bcp14 MAY]
          | be ignored for relative movements.

      +req("01.3", "Speed and Acceleration")

        t
          | Acceleration and maximum movement speed #[bcp14 MUST] be considered
          | as settings and #[bcp14 SHOULD NOT] be changed during movement.

        t
          | Acceleration #[bcp14 MUST] be available in #[tt="mm/sec^2"],
          | speed #[bcp14 MUST] be available in #[tt="mm/sec"].

      +req("01.4", "Position")
        t
          | All positions #[bcp14 MUST] be available in millimeters, with a
          | micro-metric precision.

        t
          | Current motor position #[bcp14 MAY] be directly modified on an idle motor.

        t
          | For a stepper the gear-factor (including motor resolution) #[bcp14 MUST] be configurable and
          | expressed in #[tt="step/mm"].

        +req("01.4.1", "Position Referential")

          t
            //- FIXME

      +req("01.5", "Motion queue")
        t
          | A queue for motion commands #[bcp14 MUST] be available.

        t
          | Once queued, each motion #[bcp14 MUST] be executed in sequence,
          | either automatically, or on trigger (see #[+xreq("02.1")]).

        t
          | Both relative and absolute movements #[bcp14 MAY] be queued.

        +req("01.5.1", "Motion queue pause")
          t
            | An pause command #[bcp14 MUST] be available to pause motion for
            | an amount of time, it #[bcp14 MUST] support millisecond precision.

      +req("01.6", "Pause and Resume")
        t
          | A pause and resume mechanism #[bcp14 MUST] be provided, stopping ongoing
          | motion immediately (no deceleration) and continue motion on resume.

        t
          | A #[+xreq("02.1")] #[bcp14 MAY] command #[bcp14 MAY] be paused.

        t
          | The pause and resume mechanism #[bcp14 MUST] be separate from #[+xreq("02")],
          | still the user #[bcp14 SHOULD] have the possibility to:
        ul
          li Stop motion and resume on resume command only (ignoring triggers): by calling pause.
          li Stop motion and resume on resume command re-arming the trigger: by calling pause and then re-arming trigger.
          li Stop motion immediately and resume on trigger: by arming the trigger (see #[+xreq("02")]).

      +req("01.7", "Referencement and Homing")
        t
          | As stated in #[+xreq("01.4")] current position #[bcp14 MUST] be configurable on an idle motor (using an externaly
          | measured value, such as measured what can be measured using LVDTs).

        t
          | The axis turn-direction #[bcp14 MAY] also be configured as a setting, this feature is #[bcp14 OPTIONAL].

        +req("01.7.1", "Automatic homing sequence")
          t
            | An automated homing sequence #[bcp14 MUST] be available, using hardware limit switches to reference the axis.

          t
            | Both turn-directions #[bcp14 MAY] be used for homing, either reaching the maximum end-limit or the minimum end-limit.

          t <!-- FiXME review algo -->
            | Homing #[bcp14 MAY] be achieved in several passes.

          t
            | Setting current position #[bcp14 MAY] be used in addition to the #[+xreq("01.7.1")] to
            | set home position to a different absolute value.

      +req("01.8", "End-Limits")
        t
          | Physical end-limit switches #[bcp14 MUST] be supported, some systems #[bcp14 MAY NOT] have such switches.

        t
          | Both normally-open (NO) and normally-closed (NC) switches #[bcp14 MAY] be used as end-limit switches.

        t
          | Physical end-limit switches #[bcp14 MAY] be disabled individually, totally inhibiting the given switch, the
          | switch status #[bcp14 MUST] be available at any time (even if the switch is disabled).

        t
          | Motion #[bcp14 MUST] be stopped without any deceleration whenever an end-limit is reached (unless the given switch is disabled),
          | the motion-queue #[bcp14 MUST] be flushed (see #[+xreq("01.5")]) and an error reported.

        t
          | Until the end-limit switch becomes inactive, motion requests that would go towards the switch #[bcp14 MUST] be rejected,
          | motions to move out of the switch #[bcp14 SHOULD] be accepted.

        t
          | Several physical switches #[bcp14 MAY] be used for a single end-limit (to have hardware redundancy), at least two switches
          | per end-limit #[bcp14 SHOULD] be supported.

        +req("01.8.1", "Virtual End-Limits")
          t
            | Virtual end-limits #[bcp14 SHOULD] be supported, and #[bcp14 SHOULD] be configurable as settings, this is
            | an #[bcp14 OPTIONAL] feature that #[bcp14 MAY] be disabled at runtime.

          t
            | Once enabled virtual end-limits #[bcp14 MUST] behave as physical ones, monitoring current step count ;
            | it #[bcp14 SHOULD] have step precision and be as accurate as physical switches.

      +req("01.9", "Motion Range")
        t
          | A motion-range #[bcp14 MAY] be set, defining the valid positions for the given axis, this feature is #[bcp14 OPTIONAL]
          | and #[bcp14 MAY] be disabled at runtime.

        t
          | Absolute movements out of the motion-range #[bcp14 MUST] be rejected, relative movements that moves out of the motion-range
          | #[bcp14 MAY] be rejected, a mechanism to allow relative motion out of the range #[bcp14 SHOULD] be available.

    +req("02", "Triggers")
      t
        | An hardware and software trigger mechanism #[bcp14 MUST] be available.

      t
        | A command #[bcp14 MUST] be available to arm/disarm the trigger.

      t
        | Arming the trigger during motion #[bcp14 MUST] stop any ongoing motion,
        | as if #[+xreq("01.6") pause] command sent executed, resuming motion
        | on trigger (ignoring any resume call, those are separate mechanisms).

      +req("02.1", "Triggered motion")
        t
          | Each motion command (#[+xreq("01.1")] or #[+xreq("01.2")]) #[bcp14 MAY]
          | be flagged as a triggered-motion.

        t
          | A triggered-motion #[bcp14 MUST] re-arm the trigger upon starting-up (see #[+xreq("01.6")]),
          | waiting for a software or hardware trigger to start.

    +req("03", "Resolvers or Encoders")
      t
        | Resolvers or encoders are #[bcp14 OPTIONAL] and #[bcp14 MUST] report
        | current position in millimeters.

      t
        | The current resolver position #[bcp14 MAY] be synchronized with stepper
        | step count, its current value #[bcp14 MAY] also be directly overriden,
        | it #[bcp14 SHOULD NOT] be changed during movement.

      +req("03.1", "Step-Lost detection")
        t
          | Resolvers or encoders #[bcp14 MAY] be used to enforce motion feedback step-lost detection.

        t
          | Movement #[bcp14 MUST] stop with an error whenever step-lost are detected,
          | the maximum number of accepted step-lost #[bcp14 MUST] be available as
          | a setting.

        t
          | Movement #[bcp14 MUST] stop immediately (no deceleration), only a few
          | extra steps (max 2) #[bcp14 MAY] be generated once step-lost is detected.

        t
          | Step-lost detection #[bcp14 MAY] be enabled or disabled during operation.

      +req("03.2", "Axis forced synchronization")
        t
          | Two axis position #[bcp14 MAY] be bound, relying on resolvers or encoders.

        t
          | A mechanism similar to #[+xreq("03.1")] #[bcp14 MUST]
          | be implemented to ensure reported position difference is within a certain range for two axis.

        t
          | Movement #[bcp14 MUST] stop immediately (no deceleration), some
          | extra steps (max 10) #[bcp14 MAY] be generated when the position difference difference gets out of boundaries.

        t
          | The maximum allowed position difference #[bcp14 MUST] be available as a setting.

        t
          | This mechanism #[bcp14 MUST] be available on a minimum of 4 axis (two pair of axis) per controller.

        t
          | Axis forced synchronization #[bcp14 MAY] be enabled or disabled in configuration,
          | but #[bcp14 SHOULD NOT] be enabled or disabled during operation.

          //FIXME define terminology for setting and configuration

    +req("04", "Axis State")
      t
        | The current state of each axis #[bcp14 MAY] be available, the state #[bcp14 SHOULD] be one of:
      ul
        li Idle
        li Moving Plus
        li Moving Minus
      t
        | Where "Moving Plus" and "Moving Minus" indicate if the axis is moving towards the positive or negative end limit.

    +req("05", "Driver signals")

      +req("05.1", "Driver-ready")
        t
          | Most drivers implement a driver-ready signal intended to inform the
          | controller that the driver is properly powered and suitable for operation.

        t
          | The driver-ready signal #[bcp14 MUST] be reported and accessible
          | even when driver-ready checks are disabled.

        t
          | Motion #[bcp14 MUST NOT] start if driver is not ready, it #[bcp14 MAY]
          | stop during operation if the value is de-asserted.

        t
          | If the driver in not ready, it #[bcp14 MUST] be notified as an error
          | as soon as a motion starts.

        t
          | Driver-ready checks #[bcp14 MAY] be disabled at runtime via settings,
          | ignoring the signal during motion.

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;

      references
        name Informative References

      references
        name URL References
        reference(anchor='xml2rfc' target='http://xml.resource.org')
          front
            title XML2RFC tools and documentation
            author
              organization RFC Editor
            date(year='2013')

    //- section
    //-   name Change Log
    //-   t A list of changes
    //-
    //- section
    //-   name Open Issues
    //-   t A list of open issues regarding this document
